unit acbrowsep;

interface
{---------------------------------------------------------------------------
  This code written by Bill Beam.
  Any problems, questions can be addressed to billb@catoctinsoftware.com
 (see about box)
----------------------------------------------------------------------------}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, DAO_TLB, Buttons, StdCtrls, Activex, Menus, comobj, Registry,
  ExtCtrls, ComCtrls, Inifiles
  {$IFDEF VER120}, ImgList {$ENDIF} ;

type
  TMainForm = class(TForm)
    OpenDialog1: TOpenDialog;
    Statbar: TStatusBar;
    MainMenu1: TMainMenu;
    Files: TMenuItem;
    Open1: TMenuItem;
    Close1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    gb1: TGroupBox;
    BottomPan: TPanel;
    ButPan: TPanel;
    Closebut: TBitBtn;
    Panel3: TPanel;
    tv: TTreeView;
    Panel4: TPanel;
    Panel6: TPanel;
    Refreshbut: TBitBtn;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Panel5: TPanel;
    lv: TListView;
    lpanel: TPanel;
    Memo1: TMemo;
    PropLab: TLabel;
    Panel7: TPanel;
    Options1: TMenuItem;
    MSysyes: TMenuItem;
    Himg: TImageList;
    dbSelect: TBitBtn;
    filen: TEdit;

    Function  CreateEngine : Boolean;
    Function  CreateClassFact : Boolean;
    procedure FormCreate(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    Function  Dao35Installed : boolean;
    procedure selbutClick(Sender: TObject);
    Function  DBExists(Fname : string) : boolean;
    procedure Open1Click(Sender: TObject);
    procedure ErrMessage(Emsg: String);
    procedure AddHistory;
    procedure HistoryItemClick(Sender :TObject);
    procedure ClearHistory1Click(Sender: TObject);
    Function  Histmaint(dbparm : String) : Boolean;
    procedure ClosebutClick(Sender: TObject);
    procedure FilenChange(Sender: TObject);
    procedure RefreshbutClick(Sender: TObject);
    Function  OpendB : boolean;
    procedure AddProps;
    procedure databasetree(VDB : Database);
    procedure MSysyesClick(Sender: TObject);
    Function  DontShowMsys(VDBname : string) : boolean;
    procedure tvChange(Sender: TObject; Node: TTreeNode);
    procedure lvClick(Sender: TObject);
    procedure tvExpanded(Sender: TObject; Node: TTreeNode);
    procedure RunChain(Curnode: TTreenode);
    procedure tvCollapsed(Sender: TObject; Node: TTreeNode);
    procedure Dowait;
    procedure DontWait;
    Function  ShowDAOError : Boolean;
    procedure FormResize(Sender: TObject);
    procedure MovePb(Pbval : SmallInt);
    procedure StartGauge;
private
    { Private declarations }
    MyEngine     : DBEngine;
    MyDB         : Database;
    xdb          : Database;
    ClassDBFact2 : IClassFactory2;
    DAOErrors    : Errors;
    DAOError     : Error;
    EngineOk     : Boolean;
    isClearing   : Boolean;
    HistStr      : Tstringlist;
    Locofsep     : Integer;
    props        : Properties;
    Ndbengine, Nworkspaces, Ndatabase, Ndbcon,
    Nsib1, Nsib2, Nsib3, Parentnode: TTreeNode;
    TmpItem      : TListItem;
    Save_Cursor  : TCursor;
    Hp           : Tpanel;
    Pb           : Tprogressbar;
    Sl           : Tlabel;
    lrect        : Trect;

public
    { Public declarations }
   end;

const
  ininame = 'acbrowse.ini';
  daolickey = 'mbmabptebkjcdlgtjmskjwtsdhjbmkmwtrak';
  Mencon = 'Menuitem';
  iHistsect = 'FHistory';
  iOptsect = 'Options';
  iNotFound = 'TheEnd';
  waitmsg = 'Gathering properties...Please wait';
  
var
  MainForm: TMainForm;

implementation

{$R *.DFM}
uses DAOvar, Dabout;
//-----------------------------------------------------------------------------
procedure TMainForm.About1Click(Sender: TObject);
begin
Application.CreateForm(Tdaboutfrm, Daboutfrm);
Daboutfrm.showmodal;
end;
//-----------------------------------------------------------------------------
procedure TMainForm.Close1Click(Sender: TObject);
begin
Close;
end;
//-----------------------------------------------------------------------------
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var I : Integer;
begin
if MessageDlg('Terminate this application?',
    mtConfirmation, [mbYes, mbNo], 0) = mrNo then
    action := CaNone
 else
    With TIniFile.Create(ininame) do
       begin;
           WriteBool(iOptsect, 'MSysYes', MSysYes.checked);
           {$IFDEF VER120}
           if sectionexists(iHistsect) then
              erasesection(iHistsect);
           {$ENDIF}
           {$IFNDEF VER120}
           try
             erasesection(iHistsect);
           except
           end;
           {$ENDIF}


           for i := 0 to HistStr.count - 1 do
               WriteString(iHistsect,'Menuitem' + inttostr(i), HistStr[i]);
           free;
           HistStr.free;
       end;
end;
//-----------------------------------------------------------------------------
procedure TMainForm.FormCreate(Sender: TObject);
var
  i : integer;
  s : string;
begin
EngineOk := DAO35Installed and CreateClassFact and CreateEngine;
HistStr := Tstringlist.create;
With TIniFile.Create(ininame) do
    begin
       MSysYes.checked := ReadBool(iOptsect, 'MSysYes', false);
       for I := 0 to 9 do  //only keep 10 menu items
           begin
              s := ReadString(iHistsect, Mencon + inttostr(i), iNotFound);
              if s = iNotFound then break;
              HistStr.add(s);
           end;
       free;
   end;
close1.ShortCut := ShortCut(Word('X'),[ssAlt]);
Locofsep := Files.count - 1;
AddHistory;
end;
//----------------------------------------------------------------
procedure TmainForm.MovePb(Pbval : SmallInt);
begin
Pb.Position := Pbval;
application.processmessages;
end;
//----------------------------------------------------------------
procedure TmainForm.RunChain(Curnode: TTreenode);
var
prevnode : TTreenode;
NodePos : String;
begin
NodePos := '';
//statbar.panels[0].text := '';
prevnode := Curnode;
while PrevNode <> nil do
     begin
          if PrevNode.text = cnWorkspaces then
             break;
          NodePos :=  '[' + PrevNode.text +  ']' + NodePos;
          PrevNode := PrevNode.parent;
     end;
statbar.panels[0].text := NodePos;
{while PrevNode <> nil do with statbar do
     begin
          if PrevNode.text = cnWorkspaces then
             break;
          panels[0].text :=  '[' + PrevNode.text +  ']' + Panels[0].text;
          PrevNode := PrevNode.parent;
     end;}
end;
//----------------------------------------------------------------
Function TMainForm.Dao35Installed : boolean;
begin
result := false;
with tregistry.create do
   try
       try
          rootkey:= HKEY_CLASSES_ROOT;
          result := OpenKey ('\DAO.DBEngine.35', False);
       except
          ErrMessage('Exception attempting to Openkey \DAO.DBEngine.35');
          raise;
       end;
   finally
       free;
   end;
if not result then
   ErrMessage('DAO 3.5 not installed.');
end;
//-----------------------------------------------------------------------------
Function TMainForm.CreateEngine : Boolean; //use license
begin
    MyEngine := Nil;
    try
         OleCheck(ClassDBFact2.CreateInstanceLic(
                nil,
                nil,
                DBEngine,
                DaoLicKey,
                MyEngine))
    except
         On  EOleSysError do
             begin
                ErrMessage('DBEngine would not Instantiate.');
                Raise;
             end
    end;
    result := Assigned(MyEngine);
end;
//-----------------------------------------------------------------------------
Function TMainForm.CreateClassFact : Boolean;
begin
    ClassDBFact2 := Nil;
    try
         OleCheck (CoGetClassObject (
         CLASS_DBEngine,
         CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER,
         nil,
         IClassFactory2,
         ClassDBFact2));
    except
         On  EOleSysError do
             begin
                ErrMessage('DAO.DBEngine.35 CoGetClassObject Error.');
                Raise;
             end
    end;
    Result := Assigned(ClassDBFact2);
end;
//-----------------------------------------------------------------------------
procedure TMainForm.selbutClick(Sender: TObject);
begin
with opendialog1 do
      if execute then
         filen.text := filename;
end;
//-----------------------------------------------------------------------------
Function TMainForm.DBExists(Fname : string) : boolean;
begin
result := Fileexists(Fname);
if not result then
   begin
      if filen.text = '' then
         ErrMessage('A file was not selected.')
      else
         ErrMessage(Fname + ' Not Found.');
      filen.setfocus;
   end;
end;
//-----------------------------------------------------------------------------
procedure TMainForm.Open1Click(Sender: TObject);
begin
selbutclick(sender);
end;
//-----------------------------------------------------------------------------
procedure TMainForm.ErrMessage(Emsg: String);
begin
MessageDlg(Emsg, mterror,[mbOk], 0);
end;
//-------------------------------------------------------------------------
procedure TMainForm.ClosebutClick(Sender: TObject);
begin
close;
end;
//-------------------------------------------------------------------------
procedure TMainForm.FilenChange(Sender: TObject);
begin
with filen do
     begin
        isClearing := true;
        tv.items.clear;
        lv.items.clear;
        statbar.panels[0].text := '';
        application.processmessages;
        isClearing := false;
     end;
end;
//-------------------------------------------------------------------------
procedure TMainForm.RefreshbutClick(Sender: TObject);
var
  i, j : integer;
begin
   panel7.visible := true;
   PropLab.Caption := '';
   if not fileexists(filen.text) then
      begin
         if length(filen.text) <> 0 then
            showmessage('File ' + filen.text + ' does not exist.')
         else
            showmessage(filen.text + ' No Database File specified.');
            filen.setfocus;
            exit;
      end; 
   
   if MyDB <> nil then
      MyDB.close;
   {       }
   Dowait;
   if not Opendb then
      begin
          dontwait;
          exit;
      end;
   filenchange(sender);
   {This is designed to handle multiple databases..later}

   { Engine properties }
   MovePb(5);

   props := MyEngine.properties;
   Ndbengine := TV.Items.AddObject (nil, cnEngine, Pointer (props));

   { Workspace properties }

   props := nil;
   Nworkspaces := TV.Items.AddChildObject (Ndbengine, cnWorkspaces, Pointer (props));

   For I := 0 to MyEngine.Workspaces.Count - 1 Do
      try
         props := MyEngine.Workspaces.Item[I].Properties;
         Nsib1 := TV.Items.AddChildObject (Nworkspaces, MyEngine.Workspaces.Item[I].Name,
                  Pointer (props));

         { Database properties }
         props := nil;
         Ndbcon := TV.Items.AddChildObject (Nsib1, cnDatabases, Pointer (props));

         For J := 0 to MyEngine.Workspaces.Item[I].DataBases.Count - 1 Do
            try
                props := MyEngine.Workspaces.Item[I].DataBases.Item[J].Properties;
                xdb  := nil; //for multiple databases at later time
                xdb := MyEngine.Workspaces.Item[I].DataBases.Item[J];
                Ndatabase := TV.Items.AddChildObject (Ndbcon, MyEngine.Workspaces.Item[I].DataBases.Item[J].Name,
                            Pointer (props));
                Databasetree(xdb);
            except
            end;

         { Users properties }
         props := nil;
         Nsib1 := TV.Items.AddChildobject (Nworkspaces, cnUsers, Pointer (props));
         
         For J := 0 to MyEngine.Workspaces.Item[I].Users.Count - 1 Do
            try
               props := MyEngine.Workspaces.Item[I].Users.Item[J].Properties;
               TV.Items.AddChildObject (Nsib1, MyEngine.Workspaces.Item[I].Users.Item[J].Name,
                     Pointer (props));
            except
            end;

         MovePb(80);

         { Groups properties }
         props := nil;
         Nsib1 := TV.Items.AddChildobject (Nworkspaces, cnGroups, Pointer (props));

         For J := 0 to MyEngine.Workspaces.Item[I].Groups.Count - 1 Do
            try
               props := MyEngine.Workspaces.Item[I].Groups.Item[J].Properties;
               TV.Items.AddChildObject (Nsib1, MyEngine.Workspaces.Item[I].Groups.Item[J].Name,
                     Pointer (props));
            except
            end;

      except
      end;

  MovePb(100);
  
  Dontwait;
  if NDBEngine <> nil then
     NDBEngine.expand(false);
  if histmaint(filen.text) then
     AddHistory;
end;
//-------------------------------------------------------------------------
procedure TMainform.Databasetree(VDB : Database);
var
  i, j : integer;
begin

   { Tables }
   props := nil;
   Nsib1 := TV.Items.AddChildObject (Ndatabase, cnTables, Pointer (props));
   
   For i := 0 to VDB.TableDefs.Count-1 do
      try
          {Cant depend on Type to determine this so I use the table name}
          if DontShowMsys(VDB.TableDefs.Item[i].name) then
             continue;
          props := VDB.TableDefs.Item[i].Properties;
          Nsib2 := TV.Items.AddChildObject(Nsib1, VDB.TableDefs.Item[i].name,
                    Pointer (props));
         
          {Table fields}
          props := nil;
          Nsib3 := TV.Items.AddChildObject (Nsib2, cnFields, Pointer (props));

          For j := 0 To VDB.TableDefs.Item[i].Fields.Count - 1 Do
               try
                   props := VDB.TableDefs.Item[i].Fields[j].properties;
                   TV.Items.AddChildObject(Nsib3, VDB.TableDefs.Item[i].Fields[j].Name,
                            Pointer (props));
               except
               end;

          MovePb(10);

          {Table indexes}
          props := nil;
          Nsib3 := TV.Items.AddChildObject (Nsib2, cnIndexes, Pointer (props));

          For j := 0 To VDB.TableDefs.Item[i].Indexes.Count - 1 Do
               try
                  props := VDB.TableDefs.Item[i].Indexes[j].properties;
                  TV.Items.AddChildObject(Nsib3, VDB.TableDefs.Item[i].Indexes[j].Name,
                          Pointer (props));
               except
               end;
       except
       end;

   MovePb(20);
   {Queries }

   props := nil;
   Nsib1 := TV.Items.AddChildObject (Ndatabase, cnQuerys, Pointer (props));
   
   For i := 0 to VDB.QueryDefs.Count - 1 do
     try
        if DontShowMsys(VDB.QueryDefs.Item[i].name) then
             continue;

        props := VDB.QueryDefs.Item[I].Properties;
        Nsib2 := TV.Items.AddChildObject(Nsib1, VDB.QueryDefs.Item[I].name,
                 Pointer (props));

       {Query fields}
        props := nil;
        Nsib3 := TV.Items.AddChildObject (Nsib2, cnFields, Pointer (props));
        
        For J := 0 To VDB.QueryDefs.Item[I].Fields.Count - 1 Do
           try
               props := VDB.QueryDefs.Item[I].Fields[j].properties;
               TV.Items.AddChildObject(Nsib3, VDB.QueryDefs.Item[I].Fields[J].Name,
                        Pointer (props));
           except
           end;

        MovePb(30);

        {Query Parameters}
        props := nil;
        Nsib3 := TV.Items.AddChildObject (Nsib2, cnParameters , Pointer (props));

        For J := 0 To VDB.QueryDefs.Item[I].Parameters.Count - 1 Do
           try
               props := VDB.QueryDefs.Item[I].Parameters[j].properties;
               TV.Items.AddChildObject(Nsib3, VDB.QueryDefs.Item[I].Parameters[J].Name,
                        Pointer (props));
           except
           end;
     except
     end;

    MovePb(40);

   { Recordsets}
    props := nil;
    Nsib1 := TV.Items.AddChildObject (Ndatabase, cnRecordsets, Pointer (props));

   {Recordset}
   For I := 0 to VDB.Recordsets.Count-1 Do
       try
           if DontShowMsys(VDB.Recordsets.Item[i].name) then
             continue;

           props := VDB.Recordsets.Item[I].Properties;
           Nsib2 := TV.Items.AddChildObject (Nsib1, VDB.Recordsets.Item[I].Name,
                    Pointer (props));
           For J := 0 To VDB.Recordsets.Item[I].Fields.Count-1 Do
               try
                 props := VDB.Recordsets.Item[I].Fields[J].Properties;
                 TV.Items.AddChildObject (Nsib2, VDB.Recordsets.Item[I].Fields[J].Name,
                 Pointer (props));
               except
               end;
       except
       end;

   MovePb(50);

   {Relations}
   props := nil;
   Nsib1 := TV.Items.AddChildObject (Ndatabase, cnRelations, Pointer (props));

   {relation}
   For I := 0 to VDB.Relations.Count-1 Do
       try
           if DontShowMsys(VDB.Relations.Item[i].name) then
                continue;
           props := VDB.Relations.Item[I].Properties;
           Nsib2 := TV.Items.AddChildObject (Nsib1, VDB.Relations.Item[I].Name,
                    Pointer (props));
           For J := 0 To VDB.Relations.Item[I].Fields.Count-1 Do
               try
                 props := VDB.Relations.Item[I].Fields[J].Properties;
                 TV.Items.AddChildObject (Nsib2, VDB.Relations.Item[I].Fields[J].Name,
                 Pointer (props));
               except
               end;
       except
       end;

   MovePb(60);
   
   {Containers}
   props := nil;
   Nsib1 := TV.Items.AddChildObject (Ndatabase, cnContainers, Pointer (props));

   For I := 0 to VDB.Containers.Count - 1 Do
       try
           if DontShowMsys(VDB.Containers.Item[i].name) then
             continue;

           props  := VDB.Containers.Item[I].Properties;
           Nsib2 := TV.Items.AddChildObject (Nsib1, VDB.Containers.Item[I].Name,
                     Pointer (props));

           {Containers Documents}
           props := nil;
           Nsib3 := TV.Items.AddChildObject (Nsib2, cnDocuments, Pointer (props));

           For J := 0 To VDB.Containers.Item[I].Documents.Count-1 Do
               try
                   if DontShowMsys(VDB.Containers.Item[I].Documents[J].Name) then
                      continue;
                   props := VDB.Containers.Item[I].Documents[J].Properties;
                   TV.Items.AddChildObject (Nsib3, VDB.Containers.Item[I].Documents[J].Name,
                            Pointer (props));
               except
               end;
        except
        end;

MovePb(80);
end;
//--------------------------------------------------------------------------
Function Tmainform.DontShowMsys(VDBname : string ) : boolean;
begin
   result := (pos('MSys', VDBname) = 1) and (not MSysYes.checked);
end;
//--------------------------------------------------------------------------
Function Tmainform.Opendb : boolean;
begin
   MyDB := nil;
   try
      MyDB := MyEngine.Opendatabase(filen.text, 0, True, '');
   except
      ShowDAOError;
   end;
   Result := Assigned(MyDB);
end;
//-----------------------------------------------------------------------------
Function TMainForm.ShowDAOError : Boolean;
var i : integer;
begin
    DAOErrors := MyEngine.errors;
    i := DAOErrors.count;
    result := i > 0;
    if result then  //use the most current error object
       begin
           DAOError := DAOErrors.item[i-1];
           ErrMessage(daoerror.source +
           ' ' + inttostr(daoerror.number) +
           ' ' + daoerror.description);
       end;
end;
//--------------------------------------------------------------------------
procedure tmainform.addprops;
var
  NewItem : TListItem;
  i       : integer;
  SubProp : string;
begin
  lv.items.clear;
  lv.allocby := 1;
  if props = nil then
     begin
        newitem := LV.items.add;
        newitem.Caption := 'No Properties';
        newitem.SubItems.add('No Values');
        exit;
     end;
  lv.allocby := props.Count;   
  for i := 0 to props.count - 1 do
      begin
          newitem := LV.items.add;
          with newitem do
             try
                try
                   caption := props.item[i].name;
                   SubProp := props.item[i].value;
                   if (caption = 'DefaultType') then
                       SubProp := SubProp + GWorkspaceTypeEnum(props.item[i].value)
                   else
                   if (caption = 'Attributes') and (isFields) then
                      SubProp := SubProp + GFieldAttributeEnum(props.item[i].value)
                   else
                   if (caption = 'Type') and (isFields) then
                      SubProp := SubProp + GDataTypeEnum(props.item[i].value)
                   else
                   if (caption = 'Attributes') and (isRelations) then
                      SubProp := SubProp + GRelationAttributeEnum(props.item[i].value)
                   else
                   if caption = 'CollatingOrder' then
                      SubProp := SubProp + GCollatingOrderEnum(props.item[i].value)
                   else
                   if (caption = 'Type') and (isWorkspaces) then
                      SubProp := SubProp + GWorkspaceTypeEnum(props.item[i].value)
                   else
                   if (caption = 'Type') and (isQuerys) then
                      SubProp := SubProp + GQueryDefTypeEnum(props.item[i].value)
                   else
                   if (caption = 'Direction') and (isParameters) then
                      SubProp := SubProp + GParameterDirectionEnum(props.item[i].value);

                   if caption = 'SQL' then with memo1 do
                      begin
                          PropLab.caption := newitem.caption;
                          lines.add(props.item[i].value);
                          selstart := 0 ;
                          Perform(EM_SCROLLCARET, 0, 0);
                      end;
                except
                    SubProp := 'Unknown';
                end;  {try except}
             finally
                subitems.add(SubProp);
             end {try finally}
      end; {begin}
end;
//--------------------------------------------------------------------------
Function Tmainform.Histmaint(dbparm:String) : Boolean;
var
  tempi : Integer;
begin
with HistStr do
     begin
         tempi := indexof(dbparm);     //see if already in list
         if tempi < 0 then
            begin                      //its a new entry
               insert(0,dbparm);       //insert new entry at the top
               if count = 11 then
                  delete(10);          //only maintain 10 entries 0-9
            end
         else
            if tempi <> 0 then         //if its not already at the top
               begin
                  delete(tempi);       //delete the item
                  Insert(0,dbparm);    //move it to the top
               end;
     end;
result := tempi <> 0;
end;
//-------------------------------------------------------------------------
procedure Tmainform.AddHistory;
var
  MItem   : TMenuItem;
  I, Totitems : Integer;
begin
  Totitems := Files.count - 1;
  while Totitems <> Locofsep do
      begin
         files.delete(Totitems);
         dec(Totitems);
      end;
  //filen.items.clear;
  if Histstr.count > 0 then
     begin
         MItem := TMenuItem.Create(Self);
         with Mitem do
             begin
                 Caption := 'C&lear History';
                 onClick := ClearHistory1Click;
                 Hint := 'Clear History list.';
                 Files.add(Mitem);
             end;
         MItem := TMenuItem.Create(Self);
         MItem.Caption := '-';
         Files.add(Mitem);
         for I := 0 to HistStr.count - 1 do
             begin
                MItem := TMenuItem.Create(Self);
                with MItem do
                   begin
                     onClick := HistoryItemClick;
                     Caption := '&' + inttostr(I) + ' ' + HistStr[I];
                     Files.Add(MItem);
                     //filen.items.add(HistStr[I]);
                   end;
             end;
     end;
end;
//-------------------------------------------------------------------------
procedure Tmainform.HistoryItemClick(Sender: TObject);
Begin
with sender as TmenuItem, HistStr do
     {skip accelerator char, item number and space }
     filen.text := copy(caption,4,length(caption) - 3); //set db name.
end;
//-------------------------------------------------------------------------
procedure Tmainform.ClearHistory1Click(Sender: TObject);
begin
HistStr.clear;
AddHistory;
end;
//-------------------------------------------------------------------------
procedure TMainForm.MSysyesClick(Sender: TObject);
var
  Item: TMenuItem;
begin
  Item := Sender as TMenuItem;
  Item.Checked := not Item.Checked;
end;
//-------------------------------------------------------------------------
procedure TMainForm.lvClick(Sender: TObject);
begin
with lv do
   begin
      if selcount < 1 then exit;
      TmpItem := items[selected.index];
      with memo1 do
          begin
              clear;
              panel7.visible := false;
              PropLab.caption := TmpItem.caption;
              lines.add(TmpItem.subitems[0]);
              selstart := 0;
              Perform(EM_SCROLLCARET, 0, 0);
          end;
   end;
end;
//-------------------------------------------------------------------------
procedure TMainForm.tvChange(Sender: TObject; Node: TTreeNode);
begin
{I complained about the Onchange event firing during clear.  It serves no
purpose that I can think of. Clear should do nothing but that!}
if isClearing then
   exit;
RunChain(node);
Gresetbtypes;
Props := Properties(Node.Data);
Memo1.lines.clear;
Parentnode := Node.parent;
if Parentnode <> nil then with Parentnode do
   begin
      if text = cnFields then
         isFields := true;
      if text = cnRelations then
         isRelations := true;
      if text = cnEngine then
         isEngine := true;
      if text = cnWorkspaces then
         isWorkspaces := true;
      if text = cnQuerys then
         isQuerys := true;
      if text = cnParameters then
         isParameters := true;
      if text <> cnQuerys then
         begin
            panel7.visible := true;
            PropLab.caption := '';
         end
   else
      panel7.visible := false;
   end;
addprops;
lv.column[0].caption := Node.text + ' Properties';
end;
//-------------------------------------------------------------------------
procedure TMainForm.tvExpanded(Sender: TObject; Node: TTreeNode);
begin
node.selected := true;
end;
//-------------------------------------------------------------------------
procedure TMainForm.tvCollapsed(Sender: TObject; Node: TTreeNode);
begin
node.selected := true;
end;
//-------------------------------------------------------------------------
procedure TMainForm.Dowait;
begin
Save_Cursor := Screen.Cursor;
Screen.Cursor := crHourglass;
startgauge;
end;
//-------------------------------------------------------------------------
procedure TMainForm.Dontwait;
begin
Screen.Cursor := Save_Cursor;
hp.free;
application.processmessages;
end;
//-------------------------------------------------------------------------
procedure TMainForm.FormResize(Sender: TObject); //for backward compatability
begin
  if self.width < 549 then self.width := 549;
  if self.height < 430 then self.height := 430;
  filen.left := 8;  //why? shouldn't it stay that way, d4 thing?
  filen.width := gb1.width - 16;
  butpan.left := (bottompan.Width div 2) - (butpan.width div 2);
end;
//-------------------------------------------------------------------------
{added this 4/20/99 after testing with Northwind.mdb}
procedure TMainForm.StartGauge;
begin
Hp := Tpanel.create(self);
with Hp do begin
   parent := self;
   left:=(TV.width div 2) - (width div 2);
   top:=(TV.height div 2) - (height div 2);
   name := 'Hpn';
   caption := '';
end;
Pb := Tprogressbar.create(Hp);
with Pb do begin
   parent := Hp;
   left := (parent.width div 2) - (width div 2);
   top := parent.height - height - 5;
   name := 'Gpn';
end;
Sl := Tlabel.create(Hp);
with Sl do begin
   parent := Hp;
   autosize := false;
   height := 30;
   align := alTop;
   name := 'Sln';
   caption := '';
end;
application.processmessages;
lrect := Sl.Boundsrect;
Himg.Draw(Sl.Canvas, Lrect.Left, Lrect.Top+2, 0);
Sl.canvas.textout(Lrect.left + Himg.width, Lrect.Top+2, WaitMsg);
application.processmessages;
end;
end.



